/* cc -O2 -o kostnice2 kostnice2.c; \mv kostnice2 /home/jiri/bin
 */
#include "../gen/include.h"

enum codes_e { ASCII, ISO_8859_2, CP_1250, UTF_8, N };

unsigned char *code[128][N]={
  /* ordeder by iso-8859-2 from 128 to 255 */
  /* iso-8859-2  cp-1250  Maple-win utf-8 (max 2 unsigned chars!) */
  {"","","",""},
  {"","","",""},    
  {"","","",""},    
  {"","","",""},    
  {"","","",""},    
  {"","","",""},    
  {"","","",""},    
  {"","","",""},    
  {"","","",""},    
  {"","","",""},    
  {"","","",""},    
  {"","","",""},    
  {"","","",""},    
  {"","","",""},    
  {"","","",""},    
  {"","","",""},    
  {"","","",""},    
  {"","","",""},    
  {"","","",""},    
  {"","","",""},    
  {"","","",""},    
  {"","","",""},    
  {"","","",""},    
  {"","","",""},    
  {"","","",""},    
  {"","","",""},    
  {"","","",""},    
  {"","","",""},    
  {"","","",""},    
  {"","","",""},    
  {"","","",""},    
  {"","","",""},    
  {" ","",""," "},    
  {"A","","","Ą"},    
  {" ","","","˘"},    
  {"L","","","Ł"},    
  {"$","","","¤"},    
  {"L","","","Ľ"},    
  {"S","","","Ś"},    
  {" ","","","§"},    
  {" ","","","¨"},    
  {"S","","","Š"},    
  {"S","","","Ş"},    
  {"T","","","Ť"},    
  {"Z","","","Ź"},    
  {"-","","","­"},    
  {"Z","","","Ž"},    
  {"Z","","","Ż"},    
  {" ","","","°"},    
  {"a","","","ą"},    
  {" ","","","˛"},    
  {"l","","","ł"},    
  {" ","","","´"},    
  {"l","","","ľ"},    
  {"s","","","ś"},    
  {" ","","","ˇ"},    
  {" ","","","¸"},    
  {"s","","","š"},    
  {"s","","","ş"},    
  {"t","","","ť"},    
  {"z","","","ź"},    
  {" ","","","˝"},    
  {"z","","","ž"},    
  {"z","","","ż"},    
  {"R","","","Ŕ"},    
  {"A","","","Á"},    
  {"A","","","Â"},    
  {"A","","","Ă"},    
  {"A","","","Ä"},    
  {"L","","","Ĺ"},    
  {"C","","","Ć"},    
  {"C","","","Ç"},    
  {"C","","","Č"},    
  {"E","","","É"},    
  {"E","","","Ę"},    
  {"E","","","Ë"},    
  {"E","","","Ě"},    
  {"I","","","Í"},    
  {"I","","","Î"},    
  {"D","","","Ď"},    
  {"D","","","Đ"},    
  {"N","","","Ń"},    
  {"N","","","Ň"},    
  {"O","","","Ó"},    
  {"O","","","Ô"},    
  {"O","","","Ő"},    
  {"O","","","Ö"},    
  {"x","","","×"},    
  {"R","","","Ř"},    
  {"U","","","Ů"},    
  {"U","","","Ú"},    
  {"U","","","Ű"},    
  {"U","","","Ü"},    
  {"Y","","","Ý"},    
  {"T","","","Ţ"},    
  {"ss","","","ß"},    
  {"r","","","ŕ"},    
  {"a","","","á"},    
  {"a","","","â"},    
  {"a","","","ă"},    
  {"a","","","ä"},    
  {"l","","","ĺ"},    
  {"c","","","ć"},    
  {"c","","","ç"},    
  {"c","","","č"},    
  {"e","","","é"},    
  {"e","","","ę"},    
  {"e","","","ë"},    
  {"e","","","ě"},    
  {"i","","","í"},    
  {"i","","","î"},    
  {"d","","","ď"},    
  {"d","","","đ"},    
  {"n","","","ń"},    
  {"n","","","ň"},    
  {"o","","","ó"},    
  {"o","","","ô"},    
  {"o","","","ő"},    
  {"o","","","ö"},    
  {":","","","÷"},    
  {"r","","","ř"},    
  {"u","","","ů"},    
  {"u","","","ú"},    
  {"u","","","ű"},    
  {"u","","","ü"},    
  {"y","","","ý"},    
  {"t","","","ţ"},    
  {" ","","","˙"} };

enum codes_e key2code(unsigned char *x)
{
  if (*x=='-') x++;
  switch (*x) {
  case 'a': return ASCII;
  case '8': return UTF_8;
  case 'u':
  case 'i': return ISO_8859_2;
  case 'w': return CP_1250;
  default: Error("unknown code"); }
}

int inoct,outoct;
int forceNL;

int mygetchar(void)
{
  int i,c;
  static int last=-1;

  if (last>=0) { i=last; last=-1; return i; }

  i=getchar();

  if (i<0) return -1;

  if (inoct&1 && i=='\\') {
    c=getchar();
    if (inoct&2 && c=='\n') c=getchar(),forceNL++;
    if (!isdigit(c)) { last=c; return '\\'; }
    i=c-'0';

    c=getchar();
    if (inoct&2 && c=='\n') c=getchar(),forceNL++;
    if (!isdigit(c)) { last=c; return i; }
    i=i*8+c-'0';

    c=getchar();
    if (inoct&2 && c=='\n') c=getchar(),forceNL++;
    if (!isdigit(c)) { last=c; return i; }
    i=i*8+c-'0'; }

  return i;
}

void myputs(unsigned char *c)
{
  if (outoct&2 && forceNL) printf("\n");
  if (outoct&1) {
    while (*c) if (*c>=128) printf("\\%03o",*c++); }
  else
    printf("%s",c);
  if (outoct&2 && forceNL) printf("\n"),forceNL=0;
}

int main(int narg,unsigned char **arg)
{
  enum codes_e incode,outcode;
  int i,hdr=0;

#if 0
  loop (incode,0,N) {
    loop (i,0,128) {
      int j;
      loop (j,0,i) if (code[i][incode][0])
	if (!strcmp(code[i][incode],code[j][incode]))
	  fprintf(stderr,"code=%d: char \\%o\\%o repeats in positions %d and %d\n",
		incode,code[i][incode][0],code[i][incode][1],j,i);
    } }
#endif    

  if (narg<3) {
    fprintf(stderr,"Unicode UTF-8, iso-8859-2 and cp-1250 conversion. Call by:\n\
  kostnice2 FROMCODE[MOD] TOCODE[MOD] < INPUT > OUTPUT\n\
where CODE= (one of)\n\
  -a = ASCII (remove accents of Czech characters)\n\
  -8 = Unicode UTF-8\n\
  -u = -i = iso-8859-2\n\
  -w = cp-1250 (windows)\n\
and MOD= (can repeat)\n\
   h = remove/add header of 3 bytes EF BB BF (hex)\n\
   o = octal representation of >=128 codes (e.g., \\240)\n\
   m = input: multichar and oct.number can be split between lines\n\
       output: copy these breaks to output (Maple mode)\n\
Warning: Unix format only (no CR LF)\n\
Use -u for octal <--> byte recoding only\n\
Examples:\n\
  kostnice2 -w -8 < x.rtf > x.uni  # windows -> utf-8\n\
  kostnice2 -uo -u < x.oct > x.asc # octal -> byte\n\
See also: kostnice\n\
");
    exit(0); }

  incode=key2code(arg[1]);  
  inoct=(strchr(arg[1],'o')!=NULL)+2*(strchr(arg[1],'m')!=NULL);
  if (strchr(arg[1],'h')) hdr=3;

  outcode=key2code(arg[2]);
  outoct=(strchr(arg[2],'o')!=NULL)+2*(strchr(arg[2],'m')!=NULL);
  if (strchr(arg[2],'h')) {
    putchar('\xEF');
    putchar('\xBB');
    putchar('\xBF'); }

  while ( (i=mygetchar())>=0 ) {
    if (hdr) {
      hdr--;
      switch (hdr) {
        case 2: if (i=='\xEF') goto cont;
        case 1: if (i=='\xBB') goto cont;
        case 0: if (i=='\xBF') goto cont; } }
        
    if (i>=128) {
      int c;

      loop (c,0,128) if (code[c][incode][0]==i) {
	if (strlen(code[c][incode])==1) {
	  myputs(code[c][outcode]);
	  goto cont; }
	else {
	  int j=mygetchar(),d;

	  if (inoct&2 && j=='\n') j=mygetchar(),forceNL++; 

	  loop (d,0,128) if (code[d][incode][0]==i && code[d][incode][1]==j) {
            myputs(code[d][outcode]);
	    goto cont; } } } }

    else putchar(i); 
  cont:; }

  return 0;
}
