/* cc -O2 -o l2h2 l2h2.c
 */
#include "/home/jiri/macsimus/gen/include.h"

#define BACKSPACE 12 /* kolik znaku zpet hleda mezeru pro break */
#define xDEBUG

#include "section.c"

int MAXLEN=32; /* arg[1] */

char *plaintext(char *name)
{
  static char xx[10240];
  char *c,*x;

  for (c=name,x=xx; *c; c++,x++) {
    while (*c=='<') { while (*c && *c!='>') c++; c++; }
    *x=*c; 
    if (!memcmp(c,"&nbsp;",6)) {
      *x=' '; c+=5; } }
  *x=0;

  return xx;
}

char *shorten(char *name)
{
  static char x[10240];

#ifdef DEBUG
  fprintf(stderr,"l2h2: %s\n",name);
#endif

  strcpy(x,name);

  if (strlen(name)>MAXLEN) {
    char *c,*e,*f,*w,*xx=x;
    int len=0;

    x[0]=0;

    for (c=name; *c; ) {
      switch (*c) {
        case '<':
	  /* assumed <img .. width=...> or <i> etc. with zero length */
	  w=strstr(c,"width=");
	  if (w) len+=(atoi(w+6)+4)/8;
	  e=strchr(c,'>'); if (!e) Error("l2h2: no closing >");
	  break;
        case '&':
	  e=strchr(c,';'); if (!e) Error("l2h2: no closing ;");
	  len++;
	  break;
        default:
	  e=strpbrk(c," <&");
	  if (e && strchr("<&",*e)) e--;
	  if (e) len+=e-c+1;
	  else { len+=strlen(c); e=strend(c); }
	  break; }
      if (len>MAXLEN) {
	strcat(x," ...");
	break; }
      else {
	while (c<=e) *xx++=*c++;
	*xx=0; } }
    }

#ifdef DEBUG
  fprintf(stderr,"SHORT %s\n",x);
#endif

  /* adding closing </X> -- requires b$ (cumbersome!!!); only once
     TO BE WRITTEN DIRECTLY HERE
 */
 {
   FILE *f=fopen("/tmp/end.tex","wt");
   fputs(x,f);
   fclose(f);
   if (!system("b\\$")) {
     static char xx[1024];
     xx[0]='?';
     f=fopen("/tmp/end.tex","rt");
     if (f) fgets(xx,1024,f);
     fclose(f);
     if (xx[0]=='<' && xx[1]=='/') {
       strcat(x,xx);
#ifdef DEBUG
       fprintf(stderr,"b$: %s\n",x); 
       sleep(1); 
#endif
     } } }

  return x;
}


section_t getsection(char *c)
{
  section_t r;

  c=strchr(c,' ');

  if (!c) Error("wrong MENU mark");
  sscanf(c,"%d%d%d%d%d",&r.level,r.s,r.s+1,r.s+2,r.s+3);
 
  return r;
}

#define NS 10000
section_t sec[NS];
char *text[NS];
int ns;

char *pic(int i)
{
  switch (text[i][0]) {
    case 'A': return "<img src=\"img/audio.gif\" border=0 alt=\"audio\" title=\"audio\" width=18 height=17>";
    case 'V': return "<img src=\"img/vysledek.gif\" border=0 alt=\"vsledek\" title=\"vsledek\" width=11 height=17>";
    case 'P': return "<img src=\"img/postup.gif\" border=0 alt=\"postup\" title=\"postup\" width=18 height=17>";
    case '': return "<img src=\"img/reseni.gif\" border=0 alt=\"pln een\" title=\"pln een\" width=17 height=17>";
    case 'M': return "<img src=\"img/maple.gif\" border=0 alt=\"een systmem MAPLE\" title=\"een systmem MAPLE\" width=17 height=17>";
    default: return string("<b>ERROR UNKNOWN SUBSUBSECTION (%s)</b>",text[i]); }
}

void prtpicmenu(FILE *out,int i,char *name)
{
  switch (text[i][0]) {
    case 'A': 
      fprintf(out,"<li><a href=\"#avpr\" onclick=\"appearaud(\'%s\')\" id=\"audio\">",name);
      break;    
    case 'V': 
      fprintf(out,"<li><a href=\"#avpr\" onclick=\"appearvys()\" id=\"vysledek\">");
      break;
    case 'P': 
      fprintf(out,"<li><a href=\"#avpr\" onclick=\"appearpos()\" id=\"postup\">");
      break;
    case '': 
      fprintf(out,"<li><a href=\"#avpr\" onclick=\"appearres()\" id=\"reseni\">");
      break;
    case 'M': 
      fprintf(out,"<li><a href=\"#avpr\" onclick=\"appearmap()\" id=\"maple\">");
      break;
    default: 
      fprintf(out,"<b>ERROR UNKNOWN SUBSUBSECTION (%s)</b>",text[i]); }
}

void prtafterpicmenu(FILE *out,int i,char *name)
{
  switch (text[i][0]) {
    case 'A': 
      fprintf(out,"<li class=\"aud\"><a href=\"javascript:nosound(\'%s\');\" id=\"prepzv\">Bez zvuku</a>",name);
      fprintf(out,"<li class=\"aud\" id=\"nasl\"><a href=\"javascript:audio(1,\'%s\');\">Nsledujc</a>",name);
      fprintf(out,"<li class=\"aud\" id=\"predch\"><a href=\"javascript:audio(0,\'%s\');\">Pedchoz</a>",name);
      break; }
}

int main(int narg,char **arg)
{
  FILE *in=fopen("l2h.aux","rt");
  int iarg,is;
  char line[4096],*c,C;
  section_t A;
  char *menu,*shortitem,*longitem,*item,*title;

  if (narg<3) {
    fprintf(stderr,"2nd pass of l2h, \"l2h.aux\" needed. Call by:\n\
l2h2 MAXLEN FILE(s)\n\
  MAXLEN = max len of top navigation item in chars\n\
  FILE(s) = HTML files, to be processed in place\n\
Example:\n\
  l2h2 36 index*html\n\
(Normally called from l2h.c)\n");
   exit(0); }

  MAXLEN=atoi(arg[1]);

  stringinit(512,16);

  for (c=arg[2],item=fileprefix; *c!='.'; c++,item++) {
    *item=*c;
    if (item-fileprefix>6) Error("prefix"); }
  strcat(fileprefix,".");

  fprintf(stderr,"l2h2: prefix=\"%s\"\n",fileprefix);

  /* reading l2h.aux = section numbers and names */
  ns=0;
  if (!in) Error("open l2h.aux");

  while (fgets(line,4096,in))
    if (c=strstr(line,"<!--ITEM")) {
      char auxline[4096*2];
      int cont=1;

      if (ns>=NS) Error("too many links listed in l2h.aux");

      sec[ns]=getsection(c);
      
      strcpy(auxline,sectionnumbers(sec[ns]));

      while (cont) {
        if (!fgets(line,4096,in)) Error("EOF on aux");
        if (c=strstr(line,"-->")) *c=0,cont=0;
        strcat(auxline,line); } 

      text[ns]=strdup(auxline);
      ns++; }

  fprintf(stderr,"%d links read from l2h.aux\n",ns);
  fclose(in);

  /* replacing menus and links */
  loop (iarg,2,narg) {
    FILE *out=fopen("l2h2.aux","wt");
    FILE *in=fopen(arg[iarg],"rt");

    if (!in) Error(arg[iarg]);

    while (fgets(line,4096,in)) {

      menu=strstr(line,"<!--MENU");
      title=strstr(line,"<!--TITLE");
      shortitem=strstr(line,"<!--SHORTITEM");
      longitem=strstr(line,"<!--LONGITEM");
      item=shortitem?shortitem:longitem?longitem:NULL;

      if (title) {
	c=title;
	A=getsection(c);
	C=*c; *c=0; fputs(line,out); *c=C;
	loop (is,0,ns) {
	  if (seceq(&sec[is],&A)) 
	    fprintf(out,"%s",plaintext(text[is])); } }

      else {

	if (menu || item) {
	  c=menu?menu:item;
	  A=getsection(c);
	  C=*c; *c=0; fputs(line,out); *c=C; }

	loop (is,0,ns) {
	  
	  /* making MENU (command <!--MENU in source) */
	  if (menu) {
	    section_t s=sec[is];
	    
	    s.level--;
	    
	    if (seceq(&s,&A)) {
	      s.level++;
	      fprintf(out,"<a href=\"%s\">",htmlname(s));
	      if (A.level==SUBSECTION)
	        prtpicmenu(out,is,shortbasename(s));
	       //  fprintf(out,"%s",picmenu(is));
	      fprintf(out,"%s",text[is]); /* Postup, Reseni etc. */
	      fprintf(out,"</a>");
//	      if (A.level==SUBSECTION) prtafterpicmenu(out,is,shortbasename(s));
	      if (A.level==SECTION) {
		int i,nbsp=0;
	      
		fprintf(out,"&nbsp;(");

		loop (i,0,ns) {
		  section_t ss=sec[i];
		  ss.level--;
		  if (seceq(&s,&ss))
		    fprintf(out,"%s%s",pic(i),nbsp++?"":"&nbsp;"); } 
		fprintf(out,")"); }

	      /* do not add \n here: */
	      fprintf(out,A.level==SUBSECTION?"":"<br>"); } }

	  /* <!--SHORTITEM, <!--LONGITEM (in top navigation panel) */
	  if (item)
	    if (seceq(&sec[is],&A)) 
	      fprintf(out,"%s",shortitem?shorten(text[is]):text[is]);
        } }

      if (strcmp(line,"-->\n"))
        if (!(menu || item || title)) fputs(line,out); }

    fclose(out);
    fclose(in);
    rename("l2h2.aux",arg[iarg]); }

  return 0;
}

