/* cc -O2 -o l2hcrop l2hcrop.c -lm
 */
#include "/home/jiri/macsimus/gen/include.h"

char line[256],*a;

int nx,ny,depth;
int x_0,x_1,y_0,y_1,y_c;

typedef unsigned char rgb_t[3];

rgb_t **pix;

int main(int narg,char **arg)
{
  int i,j,jj,border;
  int mod,bottom,ppm;
  FILE *f,*out;

  if (narg<3) {
    fprintf(stderr,"Special cropping for l2h.c -- css version\n\
Crops a PGM (P5) or PPM (p6) file as a result of framed $simplemath$:\n\
  - finds and removes frame\n\
  - crops the picture\n\
Call by:\n\
  l2hcrop INPUTPPM RIGHT MODULO\n\
RIGHT : white right margin added\n\
MODULO: adds white border to top and right to get multiples of MODULO\n\
Output files:\n\
  crop.ppm=the cropped picture\n\
  l2hcrop.aux=cropping info\n");
    exit(0); }

  f=fopen(arg[1],"r");
  if (!f) Error(arg[1]);
  out=fopen("crop.ppm","w");

  border=atoi(arg[2]);
  mod=atoi(arg[3]);

  fgets(line,256,f);
  if (line[0]!='P') Error("l2hcrop: not PPM/PGM");
  ppm=line[1]=='6'?3:1;
  if (!strchr("56",line[1])) Error("l2hcrop: not P5/P6");

  do {
    fputs(line,out);
    if (!fgets(line,256,f)) Error("l2hcrop: missing data");
    } while (line[0]=='#'); 

  sscanf(line,"%d%d",&nx,&ny);
  fgets(line,256,f);
  sscanf(line,"%d",&depth);
  if (depth!=255) Error("l2hcrop: bad depth");

  /* reading, omitting white page below the last pixel */
  bottom=0;
  pix=malloc(ny*sizeof(pix[0]));
  loop (j,0,ny) {
    pix[j]=malloc(nx*sizeof(pix[0][0]));
    if (!pix[j]) Error("l2hcrop: no heap");
    loop (i,0,nx)
      if (fread(pix[j][i],ppm,1,f)!=1) Error("l2hcrop: file too short");
    if (bottom) {
      loop (i,0,nx) if (pix[j][i][0]<255) goto grayfound;
      ny=j; goto resized;
     grayfound: ; }
    else
      loop (i,0,nx) if (pix[j][i][0]<255) { y_0=j; bottom++; break; } }
   resized:;
  /* .. now cropped at bottom to the lower edge of the frame */

  /* finding the frame */
  y_1=ny-1;
  j=(y_0+y_1)/2;
  loop (i,0,nx) if (pix[j][i][0]<255) { x_0=i; break; }
  loop (i,0,nx) if (pix[j][i][0]<255) x_1=i;
  while (pix[j][x_0][0]<255) {
    if (x_0>=nx) Error("l2hcrop: no frame x>nx");
    x_0++; }
  while (pix[j][x_1][0]<255) {
    if (x_0<0) Error("l2hcrop: no frame x<0");
    x_1--; }
  i=(x_0+x_1)/2;
  while (pix[y_0][i][0]<255) {
    if (y_0>=ny) Error("l2hcrop: no frame y>ny");
    y_0++; }
  while (pix[y_1][i][0]<255) {
    if (y_0<0) Error("l2hcrop: no frame y<0");
    y_1--; }
  /*..now [x_0,x_1] x [y_0,y_1] is the area inside framebox */

  /* fine determine [y_0,y_1] according to real cropping */
  y_c=(y_0+y_1+1)/2; /* center line (--> zero) */

  //  put3(y_0,y_1,y_c)
  for (; y_0<y_c; y_0++) 
    loopto (i,x_0,x_1) if (pix[y_0][i][0]<255) goto y0found;
 y0found:
  for (; y_1>y_c; y_1--) 
    loopto (i,x_0,x_1) if (pix[y_1][i][0]<255) goto y1found;
 y1found:

  /* rounding as to mod (->antialiasing) */
  while ((y_1-y_c+1)%mod) y_1++;
  while ((y_c-y_0)%mod) y_0--;

  fprintf(stderr,"%d x %d --> [%d,%d] x [%d,%d]\n",nx,ny,x_0,x_1,y_0,y_1);

  /* write cropped image */
  fprintf(out,"%d %d\n",x_1-x_0+1,y_1-y_0+1);
  fputs(line,out);
  loopto (j,y_0,y_1)
    loopto (i,x_0,x_1)
      fwrite(pix[j][i],1,ppm,out);
  fclose(out);
  fclose(f);

  f=fopen("l2hcrop.aux","wt");
  fprintf(f,"%d  x=[%d,%d]  y=[%d,%d] y_c=%d mod=%d\n",(y_1-y_c)/mod,x_0,x_1,y_0,y_1,y_c,mod);
  fclose(f);

  return 0;
}
