/* cc -g -o l2hinput l2hinput.c
 */
#include "/home/jiri/macsimus/gen/include.h"

char line[4096],fn[1024];
int nl;

FILE *f[99];

int main(int narg,char **arg)
{
  int nest=0,html=0,body=1;

  fprintf(stderr,"Make 1 TeX file by solving \\input XXX.tex. Call by:\n\
  l2hinput [INPUT1.tex INPUT2.tex [IGNORE.tex]] < MAIN.tex > MERGED.tex\n\
All \\input statements must be single on line\n\
Extension: \\inputhtml XXX.html strips <html> from file and puts it in \\html{}\n\
if INPUT1.tex INPUT2.tex are given, \\input INPUT1.tex is replaced by INPUT2.tex\n\
if IGNORE.tex is given, \\input IGNORE.tex is ignored\n");

  f[0]=stdin;


  for (;;) {
    char *ret=fgets(line,4096,f[nest]);

    if (ret && html && body && (strstr(line,"</body") || strstr(line,"</BODY") || strstr(line,"</Body")) ) {
      fputs("}\n%~+\n",stdout);
      ret=NULL; }

    if (ret) {
      char *c=line;
      int input=0,inputhtml=0;

      if (!html) {
        while (*c!=0 && *c<=' ') c++;

        input=!memcmp(c,"\\input",6) && c[6]<=' ';
        inputhtml=!memcmp(c,"\\inputhtml",10) && c[10]<=' '; }

      if (input || inputhtml) {
        char *FN;
        c+=input?6:10;
        sscanf(c,"%s",fn);

        if (narg>=3 && !strcmp(fn,arg[1])) {
          FN=arg[2];
          fprintf(stderr,"%s replaced by %s\n",fn,FN); }
        else FN=fn;

	if (input && narg==4 && !strcmp(FN,arg[3]))
	  fprintf(stderr,"%s ignored\n",FN);
	else {
	  /* ignored if fn==arg[3] */
	  nest++; 
	  if (nest>=99) Error("l2hinput: \\input nesting exceeded");
	  f[nest]=fopen(FN,"rt");
	  if (!f[nest]) Error(FN); 
	  if (inputhtml) {
	    html=body=1;
	    for (;;) {
	      if (!fgets(line,4096,f[nest])) {
		body=0; rewind(f[nest]); break; }
	      if (strstr(line,"<body") || strstr(line,"<BODY") || strstr(line,"<Body")) {
		fputs("\n%~-\n\\html{",stdout);
		body=1; break; } } } } }
      else {
        nl++;
        if (html && body) {
          char *c;

          for (c=line; *c; c++)
            if (*c=='#') fputs("\\#",stdout);
            else if (*c=='^') fputs("\\^",stdout);
            else if (*c=='_') fputs("\\_",stdout);
            else if (*c=='%') fputs("\\%",stdout);
            else if (*c=='$') fputs("\\$",stdout);
            else if (*c=='~') fputs("\\~",stdout);
            else fputc(*c,stdout); }
        else
          fputs(line,stdout); } }
    else if (nest) {
      fclose(f[nest]);
      html=0;
      nest--; }
    else break; }
  
  fprintf(stderr,"%d lines written\n",nl);
}
