/* cc -O2 -o l2htestr l2htestr.c -lm
 */
#include "/home/jiri/macsimus/gen/include.h"

char line[256];

int nx,ny,depth,maxx;

int main(int narg,char **arg)
{
  FILE *f;
  int i,j,ppm;

  if (narg<2) {
    fprintf(stderr,"Test right margin of PGM (P5) or PPM (P6) file. Call by:\n\
  l2htestr FILE\n");
    exit(0); }

  f=fopen(arg[1],"r");
  if (!f) Error(arg[1]);

  fgets(line,256,f);
  if (line[0]!='P') Error("l2htestr: not PPM/PGM");
  ppm=line[1]=='6'?3:1;
  if (!strchr("56",line[1])) Error("l2htestr: not P5/P6");

  do {
    if (!fgets(line,256,f)) Error("l2htestr: missing data");
    } while (line[0]=='#'); 

  sscanf(line,"%d%d",&nx,&ny);
  fgets(line,256,f);
  sscanf(line,"%d",&depth);
  if (depth!=255) Error("l2htestr: bad depth");

  loop (j,0,ny) {
    unsigned char rgb[3];

    loop (i,0,nx) {
      if (fread(rgb,ppm,1,f)!=1) Error("file too short");
      if (rgb[0]<255) maxx=i; } 
    if (j>1000) break; }

  fclose(f);

  f=fopen("l2htestr.aux","wt");
  fprintf(f,"%d %d\n",nx,maxx);
  fclose(f);

  return 0;
}
