#!/bin/bash
if [ $# -lt  2 ]; then
  echo "Call by:"
  echo "  makeall.sh SOURCEDIR HTMLDIR [l2h-OPTIONs]"
  echo "  makeall.sh tex prikladnik"
  echo "  makeall.sh testtex testhtml -tppm2ppm\ -\ -\ -B128\|ppmtogif -i"
  echo "input LaTeX: SOURCEDIR/main.tex (and \input files)"
  echo "input figs:  SOURCEDIR/*.gif (or .jpg)"
  echo "output HTML: HTMLDIR/index.html etc."
  echo "must be SOURCEDIR != HTMLDIR"
  echo -n "l2h : "
  l2h
else
  mkdir $2
  cd $1

# data pro vlnkovani pomoci programu vlna$
# rusi ceske deleni na spojovniku - (sorry, HTML nepodporuje)
  echo "%~dis-" > ../$2/all.in
  echo "%~dis--" >> ../$2/all.in
# rusi vkladani ~ za neslab. predlozky v rovnicich zapsanych 
# pomoci maker \bb \ee aj.
  echo "%~protect \bb \ee" >> ../$2/all.in
  echo "%~protect \Bb \Ee" >> ../$2/all.in

# udela z main.tex a vsech \input, \inputhtml jeden soubor 
# \inputhtml se preklada na \html{}, pricemz jsou nutne upravy 
# (napr. $ -> \$, zruseni vlnkovani)
  ../l2hinput html.tex l2h.tex kap.tex < main.tex >> ../$2/all.in

# WARNING: extenzivni kopirovani zruseno - vse musi byt v cilovych slozkach!
# to se tyka slozek $1/images $1/maple $1/audio $1/tabule 
# tab $1/img $2/fig(= puvodne v $1)
# a taky .css .js

  cp *.eps navod.html topright.html ../$2/
  
  
  # kopie tabulek presunuta do prikladnik.sh
#  
#  mkdir ../$2/tab
#  cp ../tab/*.{html,gif,jpg} ../$2/tab/
#  mkdir ../$2/tab/math
#  cp ../tab/math/* ../$2/tab/math
  sleep 1

# latex - potreba dal je jen main.toc
  cslatex main
  cslatex main
#  cslatex main
  echo "============== CHECK LaTeX output (Enter to continue) ================"
  read

# a zkopiruje main.toc tam, kde bude potreba
  cp main.aux ../$2/all.aux
  cp main.toc ../$2/all.toc

# vycisti adresare a strci tam obrazky, v matx jsou GIFy (vzorce) 
# z predchoziho behu, ktere se znovu pouziji podle info v math.lst
# math.lst se prenasi z tex-directory, aby v cilove neprekazel
  cp -p math.lst ../$2/
  cd ../$2/
  rm matx/*
  rmdir matx
  mv math matx
  mkdir math 
# v img jsou ikony a podobne
#  cp -p ../img/*.{gif,jpg} img/
# v $1 jsou obrazky dodane uzivatelem
#  cp -p ../$1/*.{gif,jpg} fig/

# kopiruje exace 
  cp -p ../l2h2 .
  cp -p ../l2hcrop .
  cp -p ../l2htestr .
#  cp -p ../l2hcrop2 .

# vlnkuje (~ za neslab. pedlozky)
  vlna\$ all.in all.tex

# musi odstranit ^M z DOSu, jinak LaTeX zhavaruje
  dos2unix all.tex
# odstrani mezery na konci radku (l2h je blbej a ma s tim potize)
  text all.tex
  sleep 1

  echo "run all"
# cd ..; rm l2h; makeg l2h; cd -; gdb ../l2h; sleep 3

####################################################
# tohle je hlavni engine, ktery zpracovava all.tex #
# a vola ghostscript pro vyrobu GIFu               #
####################################################
# zde se vyrobi obrazky (pokud uz nejsou) + p.*html
if ! ../l2h all "$3" "$4" "$5" "$6" "$7" "$8" "$9"; then echo "###### 1st pass l2h failed ######"; exit; fi
# .. 2nd pass se vola primo z l2h
echo "pass 2 finished"
sleep 2
mv ../$1/math.lst ../$1/math.lst~
mv math.lst ../$1/

# zip p2.zip p*.html

# 3rd pass - spoji p.*.*.*.*.html
../l2h3 p.*.*.*.html
rm p.*.*.*.[1-9].html

# BUG FIX:
lemon "</u></i>" "-</i></u>" +y p.*.html
lemon "<p><p>" "-<p>" +y p.*.html
lemon "<p><p>" "-<p>" +y p.*.html
lemon "<p><p>" "-<p>" +y p.*.html
lemon "<u></u>" "-" +y p.*.html
lemon "<i></i>" "-" +y p.*.html
lemon "<i></i>" "-" +y p.*.html
lemon "<p></div>" "-</div>" +y p.*.html
lemon "<p></Div>" "-</Div>" +y p.*.html
lemon "<p></DIV>" "-</DIV>" +y p.*.html
lemon "                       " "-X" +nX +y p.*.html
# DIRTY - no character 126=~ allowed in htmls!
charrepl 10 126 p.*.html
lemon  "<p>~</div>" "-</div>" +y p.*.html > /dev/null
lemon  "<p>~</Div>" "-</Div>" +y p.*.html > /dev/null
lemon  "<p>~</DIV>" "-</DIV>" +y p.*.html > /dev/null
charrepl 126 10 p.*.html

  beep

# uklid; ruzne pomocne soubory se presunou do ../aux/
  mkdir ../aux/
  mv topright.html l2h* *.eps aux.* *.aux all.* {ignored,images}.lst ../aux/
  rm ../aux/matx/*
  rmdir ../aux/matx
  mv matx ../aux/

  cd ..

# jeste indexy (generovani verzi uvodni stranky dle browseru)
#  index.sh

# zvyrazni warningy "WATCH RIGHT MARGIN"
  lemon WATCH aux/cropinfo.aux

  echo call \"zipall.sh\" to zip/rar all
  echo "p.html muze byt spatne (spravit rucne)"
  cp $1/p.html $2/
fi
