#!/bin/bash
if [ $# -lt 1 ]; then 
  echo "Call by (from .../multi/):"
  echo "  split.sh section"
  echo "  split.sh 2"
  exit
fi

echo =====================================================================
echo splitting $1
echo =====================================================================

rm -r p$1/
mkdir p$1
cp soundcontroller.swf p$1/

cat > p$1/sound-config.xml <<EOF
<!-- SoundManager Flash configuration -->
<!-- Sound IDs are referenced from JS -->
<!-- because of 100 audio files limit, awkwardly split into subdirectories :( -->

<items baseHref="../audio/" defaultVol="100">
EOF
fgrep p$1- sound-config.xml >> p$1/sound-config.xml
#fgrep p$1- sound-config.xml | lemon p$1- -../p$1- >> p$1/sound-config.xml
echo "</items>" >> p$1/sound-config.xml

declare -i P=$1-1
declare -i N=$1+1

for f in p.1.$1.[1-9].html p.1.$1.html ; do
  echo $f
  cat  $f | \
    lemon \"p.1.$1. -\"../p$1/p.1.$1. | \
    lemon \"p.1.$P. -\"../p$P/p.1.$P. | \
    lemon \"p.1.$N. -\"../p$N/p.1.$N. | \
    lemon \"p.1.html -\"../p.1.html | \
    lemon src=\" -src=\"../ | \
    lemon prikladnik.css -../prikladnik.css  \
  > p$1/$f
done

lemon  p.1.$1.html -p$1/p.1.$1.html +y p.1.html
