/* cc -O2 -o repl repl.c
 */
#include "../gen/include.h"

#define N 65536

int main(int narg,char **arg)
{
  char line[N];
  int nrepl=N,from=1,totrepl=0;

  if (narg<3) {
    fprintf(stderr,"Replace strings in a stream. Call by:\n\
  repl [-TIMES] FROM TO [FROM TO ...] < SOURCE > RESULT\n\
TIMES = max. number of replacements of one type (FROM->TO) per line\n\
  (default = all; use -1 in case of possible recursion)\n\
total number of replacements is returned\n\
Examples:\n\
  echo ABAA | repl A a  B bb      # -> abbaa\n\
  echo ABAA | repl -2  A a        # -> aBaA\n\
  echo ABAA | repl -1  B A  A \"\"  # -> AAA\n\
See also:\n\
  ifrepl binrepl replace lemon texrepl\n");
    exit(0); }

  if (!(narg&1)) nrepl=-atoi(arg[1]),from=2;
  if (nrepl<=0) Error("repl: TIMES undefined or TIMES<=0 or args not paired");

  while (fgets(line,N,stdin)) {
    int i;
    
    for (i=from; i<narg; i+=2) {
      int irepl,replaced=0;

      loop (irepl,0,nrepl) {
        char *c=strstr(line,arg[i]);
      
        if (c) {
          if (strlen(line)+strlen(arg[i+1])-strlen(arg[i])>=N) 
            Error("repl: buffer overflow");
          memmove(c+strlen(arg[i+1]),
                  c+strlen(arg[i]),
                  strlen(c)-strlen(arg[i])+1);
          memcpy(c,arg[i+1],strlen(arg[i+1]));      
          replaced++;
          totrepl++; } 
        if (!replaced) break; } }
    fputs(line,stdout); }
    
  return totrepl;
}

