/* common #include file for l2h.c & l2h2.c */

typedef enum enum_e { BOOK=-1,CHAPTER,SECTION,SUBSECTION,SUBSUBSECTION } level_t;
/*                          0=kapitola 1=tema  2=priklad   3=reseni.. */

typedef struct section_s {
  struct section_s *next;
  level_t level;
  int s[4]; 
} section_t;

char fileprefix[8];

int seceq(section_t *a,section_t *b)
{
  int l;

  if (a->level!=b->level) return 0;
  loopto (l,0,a->level) if (a->s[l]!=b->s[l]) return 0;

  return 1;
}

section_t *sec0;

int checkhtmlname;

/* numbers (1.2.3) in front of section name */
char *sectionnumbers(section_t sec)
{
  static char nnn[16];

  nnn[0]=0;

  if (sec.level<SUBSUBSECTION) { 
    level_t l;
    loopto (l,0,sec.level) sprintf(strend(nnn),"%d.",sec.s[l]); 
    strend(nnn)[-1]=' '; }

  return nnn;
}

char *htmlname(section_t section)
/* produces names like p.1.1.1.1.html */
{
  level_t l;
  static char line[128];
  section_t *s;

  if (section.level<BOOK || section.level>SUBSUBSECTION) return NULL;

  strcpy(line,fileprefix);
  loopto (l,0,section.level) sprintf(strend(line),"%d.",section.s[l]);
  strcat(line,"html");

  if (checkhtmlname) {
    looplist (s,sec0) if (seceq(s,&section)) return line;
    return NULL; }

  return line;
}

char *shorthtmlname(section_t section)
/* produces names like p.1.1.1.html */
{
  level_t l;
  static char line[128];
  section_t *s;

  if (section.level<BOOK || section.level>SUBSUBSECTION) return NULL;

  strcpy(line,fileprefix);
  loopto (l,0,min(section.level,2)) sprintf(strend(line),"%d.",section.s[l]);
  strcat(line,"html");

  if (checkhtmlname) {
    looplist (s,sec0) if (seceq(s,&section)) return line;
    return NULL; }

  return line;
}

char *shortbasename(section_t section)
/* produces names like p.1.1.1 */
{
  level_t l;
  static char line[128];
  section_t *s;

  if (section.level<BOOK || section.level>SUBSUBSECTION) return NULL;

  strcpy(line,fileprefix);
  loopto (l,0,min(section.level,2)) sprintf(strend(line),"%d.",section.s[l]);
  strend(line)[-1]=0;

  return line;
}
